# [746. Min Cost Climbing Stairs](https://leetcode.com/problems/min-cost-climbing-stairs/)

## Problem

You are given an integer array `cost` where `cost[i]` is the cost of `i`th step
on a staircase. Once you pay the cost, you can either climb one or two steps.

You can either start from the step with index `0`, or the step with index `1`.

Return the minimum cost to reach the top of the floor.

#### Constraints

* `2 <= cost.length <= 1000`
* `0 <= cost[i] <= 999`

#### Examples

```text
Input: cost = [10,15,20]
Output: 15
Explanation: You will start at index 1.
- Pay 15 and climb two steps to reach the top.
The total cost is 15.
```

```text
Input: cost = [1,100,1,1,1,100,1,1,100,1]
Output: 6
Explanation: You will start at index 0.
- Pay 1 and climb two steps to reach index 2.
- Pay 1 and climb two steps to reach index 4.
- Pay 1 and climb two steps to reach index 6.
- Pay 1 and climb one step to reach index 7.
- Pay 1 and climb two steps to reach index 9.
- Pay 1 and climb one step to reach the top.
The total cost is 6.
```

## Solution

```rust
pub fn min_cost_climbing_stairs(cost: Vec<i32>) -> i32 {
    assert!(cost.len() >= 2);

    let mut dp = vec![0; cost.len() + 1];
    dp[0] = cost[0];
    dp[1] = cost[1];

    for idx in 2..=cost.len() {
        dp[idx] = dp[idx - 2].min(dp[idx - 1]);
        if idx < cost.len() {
            dp[idx] += cost[idx];
        }
    }

    dp[dp.len() - 1]
}
```